#!/usr/local/bin/php
<?php 
/*
	diag_firmware.php
	part of m0n0wall (http://m0n0.ch/wall)
	
	Copyright (C) 2003 Manuel Kasper <mk@neon1.net>.
	All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:
	
	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.
	
	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.
	
	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

$d_isfwfile = 1; require("guiconfig.inc"); 

if ($_POST && !file_exists($d_firmwarelock_path)) {

	unset($input_errors);
	
	if (stristr($_POST['Submit'], "Enable"))
		$mode = "enable";
	else if (stristr($_POST['Submit'], "Disable"))
		$mode = "disable";
	else if (stristr($_POST['Submit'], "Upgrade"))
		$mode = "upgrade";
		
	if ($mode) {
		if ($mode == "enable") {
			exec_rc_script("/etc/rc.firmware enable");
			touch($d_fwupenabled_path);
		} else if ($mode == "disable") {
			exec_rc_script("/etc/rc.firmware disable");
			if (file_exists($d_fwupenabled_path))
				unlink($d_fwupenabled_path);
		} else if ($mode == "upgrade") {
			/* verify firmware image(s) */
			$fwfile = glob("{$g['ftmp_path']}/{$g['platform']}-*.img");
			if (!$fwfile[0]) {
				$fwfile = glob("{$g['ftmp_path']}/{$g['platform']}-*.bin.gz");
				if (!$fwfile[0])
					$input_errors[] = "No image file ({$g['platform']}-*.img) found.";
			}
			
			if ($fwfile[0] && file_exists($fwfile[0])) {
				if (!verify_gzip_file($fwfile[0]))
					$input_errors[] = "The image file is corrupt.";
			}

			if (!$input_errors) {			
				/* fire up the update script in the background */
				touch($d_firmwarelock_path);
				exec_rc_script_async("/etc/rc.firmware upgrade {$fwfile[0]}");
				
				$savemsg = "The firmware is now being installed. The firewall will reboot automatically.";
			}
		}
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>m0n0wall webGUI - Diagnostics: Firmware upload</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="gui.css" rel="stylesheet" type="text/css">
</head>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
      <h3><font color="#777777">Diagnostics: Firmware upload</font></h3>
            <?php if ($input_errors) print_input_errors($input_errors); ?>
            <?php if ($savemsg) print_info_box(htmlspecialchars($savemsg)); ?>
<?php if (!in_array($g['platform'], $fwupplatforms)): ?>
<p><strong>Firmware updates are not supported on this platform.</strong></p>
<?php else: ?>
            <?php if (!file_exists($d_firmwarelock_path)): ?>
            <p>Since HTTP is unreliable for transferring big firmware images, 
              the firmware has to be uploaded via FTP.<br>
              Click &quot;Enable firmware upload&quot; below to enable the FTP 
              server (not enabled by default after reboot), then upload<br>
              the image file (<?=$g['platform'];?>-*.img) via FTP
			  (use the same login credentials as for the webGUI).<br>
              <strong>Make sure to use passive mode FTP (PASV) when uploading 
              the image file!</strong><br>
              When you have uploaded the file(s), click &quot;Upgrade firmware&quot; 
              below to start the upgrade process.</p>
            <form action="diag_firmware.php" method="post">
              <table width="100%" border="0" cellpadding="6" cellspacing="0">
                <tr> 
                  <td width="100" valign="top">&nbsp;</td>
                  <td>
				  <?php if (!file_exists($d_sysrebootreqd_path)): ?>
				  <?php if (!file_exists($d_fwupenabled_path)): ?>
				  <input name="Submit" type="submit" class="formbtn" value="Enable firmware upload">
				  <?php else: ?>
				   <input name="Submit" type="submit" class="formbtn" value="Disable firmware upload">
                    <br>
                    <br>
                    <input name="Submit" type="submit" class="formbtn" value="Upgrade firmware">
				  <?php endif; else: ?>
				    <strong>You must reboot the system before you can upgrade the firmware.</strong>
				  <?php endif; ?>
                  </td>
                </tr>
                <tr> 
                  <td valign="top">&nbsp;</td>
                  <td><span class="vexpl"><span class="red"><strong>Warning:<br>
                    </strong></span>DO NOT abort the firmware upgrade once it 
                    has started. The firewall will reboot<br>
                    automatically after storing the new firmware. The configuration 
                    will be maintained.</span></td>
                </tr>
              </table>
</form>
<?php endif; endif; ?>
<?php include("fend.inc"); ?>
</body>
</html>
