#!/usr/local/bin/php
<?php 
/*
	firewall_shaper.php
	part of m0n0wall (http://m0n0.ch/wall)
	
	Copyright (C) 2003 Manuel Kasper <mk@neon1.net>.
	All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:
	
	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.
	
	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.
	
	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

require("guiconfig.inc");

if (!is_array($config['shaper']['rule'])) {
	$config['shaper']['rule'] = array();
}
$a_shaper = &$config['shaper']['rule'];

$pconfig['enable'] = isset($config['shaper']['enable']);

if ($_POST) {

	$pconfig = $_POST;

	if ($_POST['apply']) {
		$retval = 0;
		if (!file_exists($d_sysrebootreqd_path))
			$retval = shaper_configure();
		$savemsg = get_std_save_message($retval);
		if ($retval == 0) {
			if (file_exists($d_shaperconfdirty_path))
				unlink($d_shaperconfdirty_path);
		}
	} else if ($_POST['submit']) {
		$config['shaper']['enable'] = $_POST['enable'] ? true : false;
		write_config();
	
		$retval = shaper_configure();
		$savemsg = get_std_save_message($retval);
		if ($retval == 0) {
			if (file_exists($d_shaperconfdirty_path))
				unlink($d_shaperconfdirty_path);
		}
	}
}

if ($_GET['act'] == "del") {
	if ($a_shaper[$_GET['id']]) {
		unset($a_shaper[$_GET['id']]);
		write_config();
		touch($d_shaperconfdirty_path);
		header("Location: firewall_shaper.php");
		exit;
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>m0n0wall webGUI - Firewall: Traffic shaper</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="gui.css" rel="stylesheet" type="text/css">
</head>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
<form action="firewall_shaper.php" method="post">
<h3><font color="#777777">Firewall: Traffic shaper</font></h3>
<?php if ($savemsg) print_info_box(htmlspecialchars($savemsg)); ?>
<?php if (file_exists($d_shaperconfdirty_path)): ?><p>
<?php print_info_box_np("The traffic shaper configuration has been changed.<br>You must apply the changes in order for them to take effect.");?><br>
<input name="apply" type="submit" class="formbtn" id="apply" value="Apply changes"></p>
<?php endif; ?>
              <table width="100%" border="0" cellpadding="6" cellspacing="0">
                <tr> 
                  <td class="vtable"><p>
                      <input name="enable" type="checkbox" id="enable" value="yes" <?php if ($pconfig['enable'] == "yes") echo "checked";?>>
                      <strong>Enable traffic shaper<br>
                      </strong></p></td>
                </tr>
                <tr> 
                  <td> <input name="submit" type="submit" class="formbtn" value="Save"> 
                  </td>
                </tr>
              </table>
              &nbsp;<br>
              <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr> 
                  <td width="5%" class="listhdrrns">If</td>
                  <td width="5%" class="listhdrrns">Proto</td>
                  <td width="10%" class="listhdrr">Source</td>
                  <td width="10%" class="listhdrr">Port</td>
                  <td width="10%" class="listhdrr">Destination</td>
                  <td width="10%" class="listhdrr">Port</td>
                  <td width="5%" class="listhdrrns">Bandwidth</td>
                  <td width="5%" class="listhdrrns">Delay</td>
                  <td width="10%" class="listhdrrns">Mask</td>
                  <td width="20%" class="listhdr">Description</td>
                  <td width="10%" class="list"></td>
                </tr>
                <?php $i = 0; foreach ($a_shaper as $shaperent): ?>
                <tr valign="top"> 
                  <td class="listlr">
					<?php
				  $iflabels = array('lan' => 'LAN', 'wan' => 'WAN', 'pptp' => 'PPTP');
				  for ($j = 1; isset($config['interfaces']['opt' . $j]); $j++)
				  	$iflabels['opt' . $j] = $config['interfaces']['opt' . $j]['descr'];
				  echo htmlspecialchars($iflabels[$shaperent['interface']]); ?>
                  </td>
                  <td class="listr"> 
                    <?php if (isset($shaperent['protocol'])) echo strtoupper($shaperent['protocol']); else echo "*"; ?>
                  </td>
                  <td class="listr">
				    <?php echo htmlspecialchars(pprint_address($shaperent['source'])); ?>
                  </td>
                  <td class="listr">
				    <?php echo htmlspecialchars(pprint_port($shaperent['source']['port'])); ?>
                  </td>
                  <td class="listr">
				    <?php echo htmlspecialchars(pprint_address($shaperent['destination'])); ?>
                  </td>
                  <td class="listr">
				    <?php echo htmlspecialchars(pprint_port($shaperent['destination']['port'])); ?>
                  </td>
                  <td class="listr"> 
                    <?=$shaperent['bandwidth'];?>
                    Kbit/s </td>
                  <td class="listr"> 
                    <?php if ($shaperent['delay']): ?>
                    <?=$shaperent['delay'];?>
                    ms
                    <?php endif; ?>
                    &nbsp; </td>
                  <td class="listr"> 
                    <?php if ($shaperent['mask']): ?>
                    <?=$shaperent['mask'];?>
                    <?php endif; ?>
                    &nbsp; </td>
                  <td class="listbg"> 
                    <?=htmlspecialchars($shaperent['descr']);?>
                    &nbsp; </td>
                  <td valign="middle" nowrap class="list"> <a href="firewall_shaper_edit.php?id=<?=$i;?>"><img src="e.gif" width="17" height="17" border="0"></a> 
                    &nbsp;<a href="firewall_shaper.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this rule?')"><img src="x.gif" width="17" height="17" border="0"></a></td>
                </tr>
                <?php $i++; endforeach; ?>
                <tr> 
                  <td class="list" colspan="10"></td>
                  <td class="list"> <a href="firewall_shaper_edit.php"><img src="plus.gif" width="17" height="17" border="0"></a></td>
                </tr>
                <tr>
                  <td class="list" colspan="10"><strong>Note:</strong> if a packet 
                    matches multiple rules, it will be processed by all of them 
                    (delays will be summed up).</td>
                  <td class="list">&nbsp;</td>
                </tr>
              </table>
            </form>
<?php include("fend.inc"); ?>
</body>
</html>
