#!/usr/local/bin/php
<?php
/*
	vpn_ipsec.php
	part of m0n0wall (http://m0n0.ch/wall)
	
	Copyright (C) 2003 Manuel Kasper <mk@neon1.net>.
	All rights reserved.
	
	Redistribution and use in source and binary forms, with or without
	modification, are permitted provided that the following conditions are met:
	
	1. Redistributions of source code must retain the above copyright notice,
	   this list of conditions and the following disclaimer.
	
	2. Redistributions in binary form must reproduce the above copyright
	   notice, this list of conditions and the following disclaimer in the
	   documentation and/or other materials provided with the distribution.
	
	THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
	AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
	AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
	OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
	POSSIBILITY OF SUCH DAMAGE.
*/

require("guiconfig.inc");

if (!is_array($config['ipsec']['tunnel'])) {
	$config['ipsec']['tunnel'] = array();
}
$a_ipsec = &$config['ipsec']['tunnel'];
$wancfg = &$config['interfaces']['wan'];

$pconfig['enable'] = isset($config['ipsec']['enable']);

if ($_POST) {

	$pconfig = $_POST;
	
	if ($_POST['apply']) {
		$retval = 0;
		if (!file_exists($d_sysrebootreqd_path))
			$retval = vpn_ipsec_configure();
		$savemsg = get_std_save_message($retval);
		if ($retval == 0) {
			if (file_exists($d_ipsecconfdirty_path))
				unlink($d_ipsecconfdirty_path);
		}
	} else if ($_POST['submit']) {
		$config['ipsec']['enable'] = $_POST['enable'] ? true : false;
		
		write_config();
	
		$retval = 0;
		if (!file_exists($d_sysrebootreqd_path))
			$retval = vpn_ipsec_configure();
		$savemsg = get_std_save_message($retval);
		if ($retval == 0) {
			if (file_exists($d_ipsecconfdirty_path))
				unlink($d_ipsecconfdirty_path);
		}
	}
}

$ealgos = array("des" => "DES", "3des" => "3DES", "blowfish" => "Blowfish", "cast128" => "CAST128", "rijndael" => "Rijndael");
$halgos = array("md5" => "MD5", "sha1" => "SHA1");

if ($_GET['act'] == "del") {
	if ($a_ipsec[$_GET['id']]) {
		unset($a_ipsec[$_GET['id']]);
		write_config();
		touch($d_ipsecconfdirty_path);
		header("Location: vpn_ipsec.php");
		exit;
	}
}
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>m0n0wall webGUI - VPN: IPsec</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<link href="gui.css" rel="stylesheet" type="text/css">
</head>

<body link="#0000CC" vlink="#0000CC" alink="#0000CC">
<?php include("fbegin.inc"); ?>
<form action="vpn_ipsec.php" method="post">
<h3><font color="#777777">VPN: IPsec</font></h3>
<?php if ($savemsg) print_info_box(htmlspecialchars($savemsg)); ?>
<?php if (file_exists($d_ipsecconfdirty_path)): ?><p>
<?php print_info_box_np("The IPsec tunnel configuration has been changed.<br>You must apply the changes in order for them to take effect.");?><br>
<input name="apply" type="submit" class="formbtn" id="apply" value="Apply changes"></p>
<?php endif; ?>
<?php if (in_array($wancfg['ipaddr'], array('dhcp','pppoe','pptp')))
	print_info_box("Your WAN interface is not configured with a static IP address.<br>IPsec tunnels will not be active until " .
		"you configure a static IP address."); ?>
		        <table width="100%" border="0" cellpadding="6" cellspacing="0">
                <tr> 
                  <td class="vtable"><p><span class="vexpl"> </span> 
                      <input name="enable" type="checkbox" id="enable" value="yes" <?php if ($pconfig['enable'] == "yes") echo "checked";?>>
                      <strong>Enable IPsec<br>
                      </strong></p></td>
                </tr>
                <tr> 
                  <td> <input name="submit" type="submit" class="formbtn" value="Save"> 
                  </td>
                </tr>
              </table>
              &nbsp;<br>
              <table width="100%" border="0" cellpadding="0" cellspacing="0">
                <tr>
                  <td class="listhdrr">Remote net</td>
                  <td class="listhdrr">Remote gw</td>
                  <td class="listhdrr">P1 mode</td>
                  <td class="listhdrr">P1 Enc. Algo</td>
                  <td class="listhdrr">P1 Hash Algo</td>
                  <td class="listhdrrns">P1 DH Group</td>
                  <td class="listhdrrns">P2 PFS Group</td>
                  <td class="listhdr">Description</td>
                  <td class="list"></td>
				</tr>
                <?php $i = 0; foreach ($a_ipsec as $ipsecent): ?>
                <tr valign="top">
                  <td class="listlr"> 
                    <?=$ipsecent['remote-subnet'];?>
                  </td>
                  <td class="listr">
				    <?=$ipsecent['remote-gateway'];?>
                  </td>
                  <td class="listr">
				    <?=$ipsecent['p1']['mode'];?>
                  </td>
                  <td class="listr">
				    <?=$ealgos[$ipsecent['p1']['encryption-algorithm']];?>
                  </td>
                  <td class="listr">
				    <?=$halgos[$ipsecent['p1']['hash-algorithm']];?>
                  </td>
                  <td class="listr">
				    <?=$ipsecent['p1']['dhgroup'];?>
                  </td>
                  <td class="listr">
				    <?php if ($ipsecent['p2']['pfsgroup']) echo $ipsecent['p2']['pfsgroup']; else echo "off"; ?>
                  </td>
                  <td class="listbg"> 
                    <?=htmlspecialchars($ipsecent['descr']);?>&nbsp;
                  </td>
                  <td valign="middle" nowrap class="list"> <a href="vpn_ipsec_edit.php?id=<?=$i;?>"><img src="e.gif" width="17" height="17" border="0"></a> 
                    &nbsp;<a href="vpn_ipsec.php?act=del&id=<?=$i;?>" onclick="return confirm('Do you really want to delete this tunnel?')"><img src="x.gif" width="17" height="17" border="0"></a></td>
				</tr>
			  <?php $i++; endforeach; ?>
                <tr> 
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"></td>
                  <td class="list"> <a href="vpn_ipsec_edit.php"><img src="plus.gif" width="17" height="17" border="0"></a></td>
				</tr>
              </table>
            </form>
<?php include("fend.inc"); ?>
</body>
</html>
